/* mini.h   92/01/16   new tag representation included                        */

/* 96/02/01/ some instructions have been deleted for the Intel-processor */
/* #define mips 1 */

/* 96/03/01 location of environment stack changed with copy stack*/
/* #define stackchange 1 */

/* 96/06/01 counts of space requirements */
/* #define space 1 */

/* 96/07/01 variables writing in the right order for lastcall optimization */
#define variables_right_order_writing 1

#ifdef Trace_compiler_infos
#define Trace_compiler(i) printf(i);printf("\n");getchar();
#else
#define Trace_compiler(i) 
#endif

#define Compiler_VAM1P_activate 1        /* if defined - VAM1P is activated */
#define write_commands 1				 /* used for write VAM1P_commands */
#define write_xgoal 2					 /* used for write VAM1P_xgoal_command */

#define HeapCopySize		131072L
#define TrailStackSize		131072L
#define MAXTEMPVARS				64

/*
#define HeapCopySize       4096L
#define TrailStackSize     4096L
*/

#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "setjmp.h"
#include "assert.h"


#ifdef WAM

#define                     unify_void   0  /* unify_void */
#define                last_unify_void   1  /* last_unify_void */
#define                   unify_regvar   2  /* unify_regvar Ai */
#define              last_unify_regvar   3  /* last_unify_regvar Ai */
#define                 unify_localvar   4  /* unify_localvar X */
#define            last_unify_localvar   5  /* last_unify_localvar X */
#define                   unify_regval   6  /* unify_regval Ai */
#define              last_unify_regval   7  /* last_unify_regval Ai */
#define                 unify_localval   8  /* unify_localval X */
#define            last_unify_localval   9  /* last_unify_localval X */
#define                      unify_nil  10  /* unify_nil */
#define                 last_unify_nil  11  /* last_unify_nil */
#define                    unify_const  12  /* unify_constant C */
#define               last_unify_const  13  /* last_unify_constant C */
#define                     unify_list  14  /* unify_list N */
#define                last_unify_list  15  /* last_unify_list */
#define                   unify_struct  16  /* unify_struct N */
#define              last_unify_struct  17  /* last_unify_struct F,N */
#define                   write_struct  18  /* write_struct F,N */
#define                           move  19  /* move Ai,Aj */
#define                           load  20  /* load Ai,X */
#define                          store  21  /* store Ai,X */
#define                  put_local_var  22  /* put_local_var X,Ai */
#define                 put_global_var  23  /* put_global_var Ai */
#define                 put_unsafe_val  24  /* put_unsafe_val X,Ai */
#define                        put_nil  25  /* put_nil Ai */
#define                      put_const  26  /* put_const C,Ai */
#define                       put_list  27  /* put_list Ai */
#define                     put_struct  28  /* put_struct Ai,N,F/N */
#define                  get_local_val  29  /* get_local_val Ai,X */
#define                    get_reg_val  30  /* get_reg_val Ai,Aj */
#define                        get_nil  31  /* get_nil Ai */
#define                      get_const  32  /* get_const Ai,C */
#define                       get_list  33  /* get_list Ai */
#define                     get_struct  34  /* get_struct Ai,N,F/N */
#define                       allocate  35  /* allocate N */
#define                   allocate_cut  36  /* allocate_cut N */
#define                dealloc_execute  37  /* dealloc_execute P */
#define                           call  38  /* call P */
#define                     first_call  39  /* first_call N,P */
#define                        execute  40  /* execute N,P */
#define                        proceed  41  /* proceed */
#define                           fail  42  /* fail */
#define                   call_builtin  43  /* call_builtin B */
#define                dealloc_builtin  44  /* dealloc_builtin B */
#define                execute_builtin  45  /* execute_builtin B */
#define                            cut  46  /* cut N */
#define                      exit_true  47  /* exit_true */
#define                     exit_false  48  /* exit_false */
#define                     block_exit  49  /* block_exit */
#define                      block_out  50  /* block_out */
#define                       block_in  51  /* block_in */
#define                      meta_call  52  /* meta_call */
#define                       meta_and  53  /* meta_and */
#define                        meta_or  54  /* meta_or */
#define                dealloc_proceed  55  /* dealloc_proceed */
#define                         freeze  56  /* freeze N,L,V */
#define                          waken  57  /* waken N */
#define                     waken_next  58  /* waken_next */
#define                        indexng  59  /* indexng L,L */
#define                        listnil  60  /* listnil L,L,L */
#define                          noarg  61  /* noarg L */
#define                  clause_no_arg  62  /* clause_no_arg N,L */
#define                    clause_nvar  63  /* clause_nvar L,C,N,L */
#define                   clause_const  64  /* clause_const L,L,L,C,N,L */
#endif /* WAM */


#ifdef Ass

#define g_const              0		/* long */
#define g_nil              162		/* no operand */
#define g_list             254		/* 2 elements */
#define g_struct           396		/* functor and n (arity) elements */
#define g_void             124		/* no operand */
#define g_fstvar           548		/* short - offset */
#define g_nxtvar           876		/* short - offset */
#define g_meta             250		/* short - offset */
#define g_0fstvar          612		/* no operand */
#define g_0nxtvar          812		/* no operand */
#define g_1fstvar          662		/* no operand */
#define g_1nxtvar          828		/* no operand */
#define g_2fstvar          712		/* no operand */
#define g_2nxtvar          844		/* no operand */
#define g_3fstvar          762		/* no operand */
#define g_3nxtvar          860		/* no operand */

#define c_call             0		/* no operand */
#define c_lastcall         256		/* no operand */

#define h_const            512				/* long */
#define h_nil              512+2*1024		/* no operand */
#define h_list             512+3*1024		/* 2 elements */		
#define h_struct           512+4*1024		/* functor and arity elements */	
#define h_void             512+1*1024		/* no operand */
#define h_fstvar           512+5*1024		/* short */
#define h_nxtvar           512+6*1024		/* short */
#define h_fsttemp          512+8*1024		/* short */
#define h_nxttemp          512+7*1024		/* short */
#define h_fsttmp0          512+9*1024		/* no operand */
#define h_nxttmp0          512+10*1024		/* no operand */
#define h_undefproc        512+11*1024		/* no operand */

#define c_goal             15872+1*768		/* [headvars], Procptr */
#define c_nogoal           15872+2*768		/* no operand */
#define c_cut              15872+3*768		/* no operand */
#define c_builtin          15872+4*768		/* builtin predicate index */
#define c_metacall         15872+5*768		/* offset metacall variable (short) */
#define c_xgoal            15872+6*768		/* [headvars], Procptr, offset nxtvar */
#define c_undefproc        12800+3*768+1024-8 /* at end of c_3_goal */

#define c_block_in         12800
#define c_exit_block       12800+1*768
#define c_block_out        12800+2*768
#define c_1_goal           12800+3*768+152		/* Procptr */
#define c_1_xgoal          12800+3*768			/* Procptr, offset nxtvar */
#define c_2_goal           12800+3*768+664		/* Procptr */
#define c_2_xgoal          12800+3*768+512		/* Procptr, offset nxtvar */
#define c_3_goal           12800+3*768+1024		/* Procptr */
#define c_3_xgoal          12800+3*768+584		/* Procptr, offset nxtvar */
#define c_4_goal           12800+3*768+1152		/* Procptr */
#define c_4_xgoal          12800+3*768+68		/* Procptr, offset nxtvar */

#define x_general          0
#define x_nil_list         1

#define HeadMux(h_instr)    ((h_instr)>>8)
#define GoalMux(g_instr)    (g_instr)
#define ControlMux(c_instr) (c_instr)

#else

#define g_const              1      /* atom/int (long) */
#define g_nil                2      /* no operand */
#define g_list               3      /* 2 operands */
#define g_struct             4      /* functor (long) and n operands */
#define g_void               5      /* no operand */
#define g_fstvar             6      /* varoffset (short) */
#define g_nxtvar             7      /* varoffset (short) */
#define g_0fstvar            8      /* no operand */
#define g_0nxtvar            9      /* no operand */
#define g_1fstvar           10      /* no operand */
#define g_1nxtvar           11      /* no operand */
#define g_2fstvar           12      /* no operand */
#define g_2nxtvar           13      /* no operand */
#define g_3fstvar           14      /* no operand */
#define g_3nxtvar           15      /* no operand */

#define g_meta               0      /* see c_metacall and c_block */

#define c_call               1      /* no operand */
#define c_lastcall           2      /* no operand */
#define c_v1_lastcall        3      /* goalptr (long) */

#define h_const              0      /* atom/int (long) */
#define h_nil               16      /* no operand */
#define h_list              32      /* 2 operands */
#define h_struct            48      /* functor (long) and n operands */
#define h_void              64      /* no operand */
#define h_fstvar            80      /* varoffset (short) */
#define h_nxtvar            96      /* varoffset (short) */
#define h_fsttemp          112      /* varoffset (short) */
#define h_nxttemp          128      /* varoffset (short) */
#define h_fsttmp0          144      /* no operand */
#define h_nxttmp0          160      /* no operand */
#define h_undefproc        176      /* only used in one global clause */

#define c_goal             192		/* [headvars], Procptr */
#define c_nogoal           196		/* no operand */
#define c_cut              200		/* no operand */
#define c_builtin          204		/* builtin predicate index I */
#define c_metacall         208		/* offset metacall variable (short) */
#define c_undefproc        212		/* no operand */
#define c_xgoal            216		/* [headvars], Procptr, offset nxtvar */
#define c_block_in         220
#define c_exit_block       224
#define c_block_out        228
#define c_1_goal           232		/* Procptr */
#define c_2_goal           236		/* Procptr */
#define c_3_goal           240		/* Procptr */
#define c_4_goal           244		/* Procptr */
#define c_1_xgoal          248		/* Procptr, offset nxtvar */
#define c_2_xgoal          252		/* Procptr, offset nxtvar */
#define c_3_xgoal          256		/* Procptr, offset nxtvar */
#define c_4_xgoal          260		/* Procptr, offset nxtvar */
#define c_v1_xgoal         264      /* [headvarcount(short),] procptr (long), headptr (long), vam1pcodeptr (long), varoffset */

#define v1_unify_const       0		/* long */
#define v1_unify_nil         1		/* no operand */
#define v1_unify_list        2		/* 2 elements */
#define v1_lastcall          c_v1_lastcall  /* first subgoal pointer (long) */
#define v1_unify_last_list   4		/* 2 elements */
#define v1_unify_struct      5		/* functor and n elements */
#define v1_unify_last_struct 6		/* functor and n elements */
#define v1_unify_void        7		/* no operand */
#define v1_unify_fsttmp      8		/* short */
#define v1_unify_nxttmp      9		/* short */
#define v1_unify_fsttmp0    10		/* no operand */
#define v1_unify_nxttmp0    11		/* no operand */
#define v1_unify_fstvar     12		/* short */
#define v1_unify_nxtvar     13		/* short */
#define v1_unify_0fstvar    14		/* no operand */
#define v1_unify_0nxtvar    15		/* no operand */
#define v1_unify_1fstvar    16		/* no operand */
#define v1_unify_1nxtvar    17		/* no operand */
#define v1_unify_2fstvar    18		/* no operand */
#define v1_unify_2nxtvar    19		/* no operand */
#define v1_unify_3fstvar    20		/* no operand */
#define v1_unify_3nxtvar    21		/* no operand */
#define v1_pop              22		/* no operand */
#define v1_fstvar_const     23		/* short, long  */
#define v1_nxtvar_const     24		/* short, long  */
#define v1_fsttmp_const     25		/* short, long  */
#define v1_nxttmp_const     26		/* short, long  */
#define v1_fsttmp0_const    27		/* short, long  */
#define v1_nxttmp0_const    28		/* short, long  */
#define v1_fstvar_nil       29		/* short, no operand  */
#define v1_nxtvar_nil       30		/* short, no operand  */
#define v1_fsttmp_nil       31		/* short, no operand  */
#define v1_nxttmp_nil       32		/* short, no operand  */
#define v1_fsttmp0_nil      33		/* no operand, no operand  */
#define v1_nxttmp0_nil      34		/* no operand, no operand  */
#define v1_fstvar_list      35		/* short, 2 elements  */
#define v1_nxtvar_list      36		/* short, 2 elements  */
#define v1_fsttmp_list      37		/* short, 2 elements  */
#define v1_nxttmp_list      38		/* short, 2 elements  */
#define v1_fsttmp0_list     39		/* no operand, 2 elements  */
#define v1_nxttmp0_list     40		/* no operand, 2 elements  */
#define v1_fstvar_struct    41		/* short, functor and n elements */
#define v1_nxtvar_struct    42		/* short, functor and n elements */
#define v1_fsttmp_struct    43		/* short, functor and n elements */
#define v1_nxttmp_struct    44		/* short, functor and n elements */
#define v1_fsttmp0_struct   45		/* no operand, functor and n elements */
#define v1_nxttmp0_struct   46		/* no operand, functor and n elements */
#define v1_fstvar_void      47		/* short, no operand */
#define v1_fsttmp_void      48		/* short, no operand */
#define v1_fsttmp0_void     49		/* no operand, no operand */
#define v1_fstvar_fstvar    50		/* short, short */
#define v1_fstvar_nxtvar    51		/* short, short */
#define v1_fstvar_fsttmp    52		/* short, short */
#define v1_fstvar_nxttmp    53		/* short, short */
#define v1_fstvar_fsttmp0   54		/* short, no operand */
#define v1_fstvar_nxttmp0   55		/* short, no operand */
#define v1_fsttmp_nxtvar    56		/* short, short */
#define v1_fsttmp0_nxtvar   57		/* no operand, short */
#define v1_nxtvar_nxtvar    58		/* short, short */
#define v1_nxtvar_nxttmp    59		/* short, short */
#define v1_nxtvar_nxttmp0   60		/* short, no operand */

#define v1_goal             61		/* not used */
#define v1_builtin          62		/* not used */
#define v1_metacall         63		/* not used */
#define v1_xgoal            64		/* [headvarcount(short),] v1_procptr (long), headptr (long), v1_codeptr (long), varoffset */

#define x_general          0
#define x_nil_list         1

#define HeadMux(h_instr)            ((h_instr)>>4)
#define GoalMux(g_instr)            (g_instr)
#define ControlMux(c_instr)         (c_instr)
#define UnifyMux(v1_instr)          (v1_instr)
#define CopyMux(v1_instr)           (v1_instr)

#endif /* Ass */


#define Combine(h_instr, g_instr)   ((h_instr)+(g_instr))
#define combine_compiler(h_instr, g_instr)   ((h_instr)+(g_instr))

#define bip_exit_true        0
#define bip_exit_fail        1


#define TRUE                 1
#define FALSE                0

#define Success              0
#define Fail                 1
#define SystemError          2
#define SyntaxError          3
#define OperatorError        4
#define EndOfInputError      5
#define OutOfMemoryError     6
#define FileOpenError        7
#define UndefProcError       8
#define NotImplementedError  9
#define InvalidGoalError    10
#define OutOfVarsError      11
#define TooManyFilesError   12
#define ExitTrueError       13
#define ExitFailError       14
#define BuiltinInstError    15
#define BuiltinTypeError    16
#define BuiltinRangeError   17
#define BuiltinOpError      18
#define StackOverflowError  19
#define CopyOverflowError   20
#define NoBlockError        21

#define MaxPriority         1200

typedef short               SHORT, CODE, *CODEPTR;
typedef unsigned short      UCODE;
typedef long                MW, *MWPTR;
typedef char                BYTE, *CHARPTR;
typedef int                 (*BIPPTR)();

#define SIZEMW              sizeof(MW)
#define SIZECHAR            sizeof(char)
#define SIZECODE            sizeof(CODE)
#define LopSize             (SIZEMW/SIZECODE)

#define BuiltinSize           100

typedef struct BUILTIN_TAB {
        MW      bt_name;
        MW      bt_arity;
        int     (*bt_bipptr)();
#ifdef Ass
        long    bt_lfiller;
#endif
        } BIP_TAB;

#ifdef Mini2

#define UndefSelfRef

#define VAL_MASK            -8L
#define ATOM_MASK           0x03FFFFFFL
#define PTR_TAG_MASK        3L
#define TAG_MASK            7L
#define ATOM_TAG            4L
#define INT_TAG             0L
#define REF_TAG             1L
#define LIST_TAG            2L
#define STRUCT_TAG          3L

#define MakeUndef(mp)       (((MW)(mp))+REF_TAG)
#define MakeVarUndef        REF_TAG
#define MakeNil             (-4)
#define MakeRef(mp)         (((MW)(mp))+REF_TAG)
#define MakeAtom(di)        (((di)<<3)+ATOM_TAG)
#define MakeInt(m)          ((m)<<3)
#define MakeList(mp)        (((MW)(mp))+LIST_TAG)
#define MakeStruct(mp)      (((MW)(mp))+STRUCT_TAG)

#define XtrRef(m)           ((MWPTR)((m)-REF_TAG))
#define XtrInt(m)           ((m)>>3)
#define XtrAtomPtr(m)       ((char*)(HeapStart+((m)>>3)))
#define XtrAtomIndex(m)     ((m)>>3)
#define XtrList(m)          ((MWPTR)((m)-LIST_TAG))
#define XtrStruct(m)        ((MWPTR)((m)-STRUCT_TAG))

#define Undef(m)            ((((m) & PTR_TAG_MASK) == REF_TAG) && \
                             ((m) == *(XtrRef(m))))
#define RefUndef(m)         (((m) & PTR_TAG_MASK) == REF_TAG)
#define VarUndef(m)         ((m)==REF_TAG)
#define NotUndef(m)         ((((m) & PTR_TAG_MASK) != REF_TAG) || \
                             ((m) != *(XtrRef(m))))
#define NotRefUndef(m)      (((m) & PTR_TAG_MASK) != REF_TAG)
#define Val(m)              (((m) & PTR_TAG_MASK) != REF_TAG)
#define NotVal(m)           (((m) & PTR_TAG_MASK) == REF_TAG)
#define Ref(m)              ((((m) & PTR_TAG_MASK) == REF_TAG) && \
                             ((m) != *(XtrRef(m))))
#define RefOrUndef(m)       (((m) & PTR_TAG_MASK) == REF_TAG)
#define ListOrStruct(m)     (((m) & LIST_TAG) == LIST_TAG)
#define Nil(m)              ((m) == -4)
#define NotNil(m)           ((m) != -4)

#define Deref(m, mptr)      TraceInstr("t_firstderef") do \
                            {TraceInstr("t_allderef") m= *(mptr=XtrRef(m));} \
                            while(RefOrUndef(m)&&((m)!=(((MW)mptr)+REF_TAG)))
#define StructDeref(m,mp)   TraceInstr("t_firstderef") \
                            while(RefOrUndef(m)&&((m)!=(((MW)mp)+REF_TAG))) \
                            {TraceInstr("t_allderef") m= *(mp=XtrRef(m));}
#define ValDeref(m)         TraceInstr("t_firstderef") while(Ref(m)) \
                            {TraceInstr("t_allderef") m= *(XtrRef(m));}
                            
#else /* Mini2 */

#define VAL_MASK            0x1FFFFFFFL
#define ATOM_MASK           0x03FFFFFFL
#define TAG_MASK            0xE0000000L
#define PTR_TAG_MASK        0xE0000000L
#define ATOM_TAG            0xE0000000L
#define INT_TAG             0xA0000000L
#define LIST_TAG            0x80000000L
#define STRUCT_TAG          0xC0000000L

#define MakeUndef(mp)       0
#define MakeVarUndef        0
#define MakeNil             (-1)
#define MakeRef(mp)         ((MW)(mp))
#define MakeAtom(di)        ((di)|ATOM_TAG)
#define MakeInt(m)          (((m)&VAL_MASK)|INT_TAG)
#define MakeList(mp)        ((((MW)(mp))>>2)|LIST_TAG)
#define MakeStruct(mp)      ((((MW)(mp))>>2)|STRUCT_TAG)

#define XtrRef(m)           ((MWPTR)(m))
#define XtrInt(m)           (((m)<<3)>>3)
#define XtrAtomPtr(m)       ((char*)(HeapStart+((m)&ATOM_MASK)))
#define XtrAtomIndex(m)     ((m)&ATOM_MASK)
#define XtrList(m)          ((MWPTR)((m)<<2))
#define XtrStruct(m)        ((MWPTR)((m)<<2))

#define Undef(m)            ((m)==0)
#define RefUndef(m)         ((m)==0)
#define VarUndef(m)         ((m)==0)
#define NotUndef(m)         ((m)!=0)
#define NotRefUndef(m)      ((m)!=0)
#define Val(m)              ((m)<0)
#define NotVal(m)           ((m)>=0)
#define Ref(m)              ((m)>0)
#define RefOrUndef(m)       ((m)>0)
#define ListOrStruct(m)     (((m) << 2) > 0)
#define Nil(m)              ((m) == -1)
#define NotNil(m)           ((m) != -1)

#define Deref(m, mptr)      TraceInstr("t_firstderef") do \
                            {TraceInstr("t_allderef") m= *(mptr=XtrRef(m));} \
                            while(Ref(m))
#define StructDeref(m,mp)   if(Ref(m))TraceInstr("t_firstderef") while(Ref(m)) \
                            {TraceInstr("t_allderef") m= *(mp=XtrRef(m));}
#define ValDeref(m)         if(Ref(m))TraceInstr("t_firstderef") while(Ref(m)) \
                            {TraceInstr("t_allderef") m= *(XtrRef(m));}
                            
#endif /* Mini2 */


#define Int(m)              (((m) & TAG_MASK) == INT_TAG)
#define NotInt(m)           (((m) & TAG_MASK) != INT_TAG)
#define Atom(m)             (((m) & TAG_MASK) == ATOM_TAG)
#define NotAtom(m)          (((m) & TAG_MASK) != ATOM_TAG)
#define List(m)             (((m) & PTR_TAG_MASK) == LIST_TAG)
#define NotList(m)          (((m) & PTR_TAG_MASK) != LIST_TAG)
#define Struct(m)           (((m) & PTR_TAG_MASK) == STRUCT_TAG)
#define NotStruct(m)        (((m) & PTR_TAG_MASK) != STRUCT_TAG)

#define CreateList(mp)      TraceInstr("t_makelist") TraceInstr("t_copyallocs") \
                            TraceAdd(t_copyallocsize,2) \
                            *mp=MakeList(copyptr-=2);CopyCheck mp=copyptr             /* stackchange: no modification */
#define CreateList2(m, mp)  TraceInstr("t_makelist") TraceInstr("t_copyallocs") \
                            TraceAdd(t_copyallocsize,2) \
                            m=MakeList(copyptr-=2);CopyCheck mp=copyptr               /* stackchange: no modification */
                            
#define IndexPtr(x)         ((char*)(HeapStart+(x)))/* change index to pointer */
#define FunctArity(f)       ((f)[0])                /* arity of functor        */
#define FunctIndex(f)       ((f)[1])                /* atom index of functor   */
#define FunctProc(f)        (((MWPTR*)(f))[2])      /* pointer to procedure    */
#define XtrFunctor(mp)      ((MWPTR)*(mp))
#define XtrArity(mp)        (FunctArity(XtrFunctor(mp)))
#define FirstArgPtr(mp)     ((mp)+1)
#define StructHeadUnify(p,q)    if(*p++ != *q++)return(FALSE)

#define InstrFetch(iptr)        (*iptr++)
#define InstrRead(iptr)         (*(iptr))
#ifdef NoUnalignedAccess
#define LopRead(ip)             (((MW)(*((CODEPTR)(ip)))<<16)+*(((UCODE *)(ip))+1))
#define CodeStructUnify(hp,gp)  if((*gp++)!=(*hp++)){FailInstr(h_struct_g_struct)goto fail;} \
                                if((*gp++)!=(*hp++)){FailInstr(h_struct_g_struct)goto fail;}
#define CompileCodeStructUnify(hp,gp)  if((*gp++)!=(*hp++)){FailInstr(h_struct_g_struct)goto compile_fail;} \
                                if((*gp++)!=(*hp++)){FailInstr(h_struct_g_struct)goto compile_fail;}
#else
#define LopRead(iptr)           (*((MWPTR)(iptr)))
#define CodeStructUnify(hp,gp)  if(*((MWPTR)gp)!=*((MWPTR)hp)){FailInstr(h_struct_g_struct)goto fail;} \
                                gp+=LopSize;hp+=LopSize;
#define CompileCodeStructUnify(hp,gp)  if(*((MWPTR)gp)!=*((MWPTR)hp)){FailInstr(h_struct_g_struct)goto compile_fail;} \
                                gp+=LopSize;hp+=LopSize;
#endif
#define LopFetch(m, iptr)       m=LopRead(iptr);iptr+=LopSize
#define SopRead(iptr)           (*(iptr))
#define SopFetch(iptr)          (*iptr++)
#define InstrStore(iptr,i)      (*iptr++)=(CODE)(i)
#ifdef NoUnalignedAccess
#define LopStore(iptr, m)       *iptr=(CODE)((m)>>16);*(iptr+1)=(CODE)(m); \
                                iptr+=LopSize
#else
#define LopStore(iptr, m)       *((MWPTR)iptr)=(MW)(m);iptr+=LopSize
#endif
#define SopStore(iptr, s)       (*iptr++)=(CODE)(s)
#define LIncr(iptr)             iptr+=LopSize
#define SIncr(iptr)             iptr++
#define SDecr(iptr)             iptr--
#define LDecr(iptr)             iptr-=LopSize
#define ArityFetch(ip)          (FunctArity((MWPTR)(LopRead(ip))))
#define AritySkip(ip)           (0)
#define FunctorFetch(ip)        ((MWPTR)LopRead(ip))
#define FirstArgIncr(ip)        ip+=LopSize

/* stackchange: no modification */
#define FetchStruct(mp, ip, i)  TraceInstr("t_copyallocs") TraceAdd(t_copyallocsize,i+1) \
                                *mp=MakeStruct(copyptr-=(1+(i)));mp=copyptr; \
                                                                CopyCheck *mp++ = LopRead(ip);ip+=LopSize
/* stackchange: no modification */
#define FetchStruct4(m, mp, ip, i) TraceInstr("t_copyallocs") TraceAdd(t_copyallocsize,i+1) \
                                m=MakeStruct(copyptr-=(1+(i)));mp=copyptr; \
                                                                CopyCheck *mp++ = LopRead(ip);ip+=LopSize

#define BlockSize           9
#define BlockBlock(mp)      (*((MWPTR)(mp)))
#define BlockCopy(mp)       (*(((MWPTR)(mp))+1))
#define BlockTrail(mp)      (*(((MWPTR)(mp))+2))
#define BlockStack(mp)      (*(((MWPTR)(mp))+3))
#define BlockFrame(mp)      (*(((MWPTR)(mp))+4))
#define BlockCode(mp)       (*(((MWPTR)(mp))+5))
#define BlockCall(mp)       (*(((MWPTR)(mp))+6))
#define BlockBall(mp)       (*(((MWPTR)(mp))+7))
#define BlockExit(mp)       (*(((MWPTR)(mp))+8))
#define FrameSize(ip)       (*((ip)-(LopSize+1)))
#define AddClauseHeader(ip) ((CODEPTR)(((MWPTR)(ip))+5))  /* counts space requirements; +5 instead of +6 */
#define Indexing(ip)        (*(((CODEPTR)(ip))-(LopSize+1)))
#define AvlFlag(ip)         (*(((CODEPTR)(ip))-(LopSize+2)))
#define Alternative(ip)     (*(((MWPTR*)(ip))-1))
#define Equal(ip)           (*(((MWPTR*)(ip))-3))
#define Greater(ip)         (*(((MWPTR*)(ip))-4))
#define Less(ip)            (*(((MWPTR*)(ip))-5))
#define EqualOffset(p)      (((MWPTR*)(p))-3)
#define GreaterOffset(p)    (((MWPTR*)(p))-4)
#define LessOffset(p)       (((MWPTR*)(p))-5)
#define ClauseList(p)       ((MWPTR)((p)[-3]))
#define ClauseNil(p)        ((MWPTR)((p)[-4]))
#define ClauseConst(p)      ((MWPTR)((p)[-5]))
#define write_header_copyspace_required(ip) (*(((MWPTR*)(ip))-6)) /* counts space requirements*/
#define read_header_copyspace_required(p)  ((MW)((p)[-6])) /* counts  space requirements */

#define ProcSize            3
#define ProcOffset(p)       (((MWPTR*)(p))[0])
#define ProcFunctor(p)      (((MWPTR*)(p))[1])
#define ProcLastClause(p)   (((MWPTR*)(p))[2])
#define ProcArity(p)        (FunctArity(ProcFunctor(p)))
#define ProcList(p)         ((MWPTR)((p)[-2]))
#define ProcNil(p)          ((MWPTR)((p)[-3]))
#define ProcConst(p)        ((MWPTR)((p)[-4]))

#define IsUndefProc(p)      ((((MWPTR)(p))==HeapStart)|| \
                             (((CODEPTR)(p))==((CODEPTR)HeapStart+1)))
#define CallAndCheck(func)  {if(func != Success)return(ErrorNumber);}
#define Pointsto(p,q)       ((p) < (q))

extern MW copyspace_required;

#ifdef debugVam12p
#define TraceCopySpace_required	printf("\ncopyspace_required: %lu Bytes (*4)\n",copyspace_required)
								/*printf("CopyStart               : %lu\n",CopyStart);\
								printf("copyptr                 : %lu\n",copyptr);\
								printf("HeapStart               : %lu\n",HeapStart);\
								printf("heapptr                 : %lu\n",heapptr);\
								printf("CopyStackSize           : %lu\n",CopyStart-copyptr);\
								printf("copyspace_required (*4) : %lu\n",copyspace_required);\*/
#define TraceSwitchVam12p printf("UnifyMux-v1_lastcall\n");
#define TraceCountGoals(j)
/* #define TraceCountGoals(j) printf("%i. goal\n",j); */
#define Tracerequiredcopyspace(j) printf("%ld space needed in interpreter.\n",j);
#define TraceCodeGeneration(x) printf(x);
#define TraceCodeGeneration_1Parameter(x,y) printf(x,y);
#else
#define TraceCopySpace_required
#define TraceSwitchVam12p
#define TraceCountGoals(j)
#define Tracerequiredcopyspace(j)
#define TraceCodeGeneration(x)
#define TraceCodeGeneration_1Parameter(x,y)
#endif
/* ================================================================================= */


#ifdef stackchange
#define CopyCheck	if(((long unsigned) 4*(copyspace_required) >= (long unsigned) HeapCopySize/2) || \
					((MWPTR)heapptr>=copyptr)) {assert(FALSE);\
					return(ErrorNumber=CopyOverflowError);}
#else
#define CopyCheck	if((MWPTR)trail>=copyptr) \
					return(ErrorNumber=CopyOverflowError);
#endif
 
#ifdef stackchange
#define LocalStackCheck	if(stackptr<=(MWPTR)trail) \
						return(ErrorNumber=StackOverflowError) 
#else
#define LocalStackCheck	if(stackptr<=heapptr) \
						return(ErrorNumber=StackOverflowError)
#endif

                                                
/* -x (1 x is 4bytes) because copystack/environment stack grow from top to bottom */
#define NewLocalStackCheck(x)	if((stackptr-x*4)<=(MWPTR)trail) \
								return(ErrorNumber=StackOverflowError) 
#define NewCopyCheck(x)	if(((long unsigned) 4*(x) >= (long unsigned) HeapCopySize/2) || \
						((MWPTR)heapptr>=copyptr-(4*x))) {assert(FALSE);\
						return(ErrorNumber=CopyOverflowError);}
#define PushChoicePoint(goalptr, headptr)  \
                stackptr -= 6;                     \
                *(stackptr+5) = (MW) (goalptr);    \
                *(stackptr+4) = (MW) goalframeptr; \
                *(stackptr+3) = (MW) (headptr);    \
                *(stackptr+2) = (MW) trail;        \
                *(stackptr+1) = (MW) copyptr;      \
                *stackptr     = (MW) choicepntptr; \
                choicepntptr = stackptr                               /* stackchange: no modification */ 
#define PopChoicePoint                              \
                stackptr = choicepntptr + 6;                \
                goalptr      = (CODEPTR) *(choicepntptr+5); \
                goalframeptr = (CHARPTR) *(choicepntptr+4); \
                headptr      = (CODEPTR) *(choicepntptr+3); \
                trail        = (MWPTR*)  *(choicepntptr+2); \
                copyptr      = (MWPTR)   *(choicepntptr+1); \
                choicepntptr = (MWPTR)   *choicepntptr;
#ifdef Ass
#define DerefChoicePntPtr   choicepntptr = (MWPTR) *(choicepntptr)
#define LastCopy            ((MWPTR) *(choicepntptr+4))
#else
#define DerefChoicePntPtr   choicepntptr = (MWPTR) *choicepntptr
#define LastCopy            ((MWPTR) *(choicepntptr+1))
#endif
#ifdef Comp
#define Trail(mptr)         TraceInstr("t_trail_check") if((mptr)>=LastCopy) \
                            {TraceInstr("t_trail") *trail++=(MWPTR) MakeRef(mptr);CopyCheck}
#else
#define Trail(mptr)         TraceInstr("t_trail_check") if((mptr)>=LastCopy) \
                            {TraceInstr("t_trail") *trail++=(mptr);CopyCheck}
#endif



/* stackchange: no modification */
#define MakeCopyUndef       TraceInstr("t_copyundef") copyptr--; \
                            *copyptr=MakeUndef(copyptr); CopyCheck              
/* stackchange: no modification */
#define PushCopyStack(m)    *(--copyptr) = (m); CopyCheck                       
/* stackchange: no modification */
#define PushCopyStackVar(m,p) \
                copyptr--; if (VarUndef(m)) *copyptr=MakeUndef(copyptr); \
                else if((RefOrUndef(m))&&((p=XtrRef(m))<copyptr)) \
                        {if(VarUndef(*copyptr= *p))*copyptr=MakeUndef(copyptr); \
                        *p=MakeRef(copyptr);} \
                else *copyptr=(m); CopyCheck                                       
/* stackchange: no modification */
#define PushFunctor(f)      *(--copyptr) = ((MW)(f))                               
/* stackchange: no modification */
#define CreateStruct(p,f,a) TraceInstr("t_copyallocs") TraceAdd(t_copyallocsize,a+1) \
                            *p=MakeStruct(copyptr-=(1+(a)));p=copyptr; \
                            *((MWPTR*)p)=(f);p++; CopyCheck




#define AssignSuccess(p, m) {Trail(p); *p = (m); return(Success);}
#define AssignCont(p, m)    {Trail(p); *p = (m); continue;}

#define AdjustCharPtr(cp)   ((MWPTR)((((MW)cp)+(int)SIZEMW-(int)SIZECHAR)&((MW)-(int)SIZEMW)))
#define AdjustCodePtr(cp)   ((MWPTR)((((MW)cp)+(int)SIZEMW-(int)SIZECODE)&((MW)-(int)SIZEMW)))

#ifdef Atari
#define open_r(file)        fopen(file, "rb")
#define open_w(file)        fopen(file, "wb")
#else /* Atari */
#define open_r(file)        fopen(file, "r")
#define open_w(file)        fopen(file, "w")
#endif /* Atari */

/* mini.c */

extern  int     ErrorNumber;
extern  FILE    *infile;
extern  FILE    *outfile;
extern  MW      infile_name;
extern  MW      outfile_name;

void m_error(int errnr);


/* mb.c */

extern MWPTR *ctbottom;

int b_cputime(MW arg[]);
int b_fail(void);
int b_atom(MW arg[]);
int b_atomic(MW arg[]);
int b_compound(MW arg[]);
int b_integer(MW arg[]);
int b_list(MW arg[]);
int b_nil(MW arg[]);
int b_nonvar(MW arg[]);
int b_number(MW arg[]);
int b_struct(MW arg[]);
int b_var(MW arg[]);
int b_int_eq(MW arg[]);
int b_int_ne(MW arg[]);
int b_int_lt(MW arg[]);
int b_int_le(MW arg[]);
int b_int_gt(MW arg[]);
int b_int_ge(MW arg[]);
int b_is(MW arg[]);
int b_dec(MW arg[]);
int b_inc(MW arg[]);
int b_arg(MW arg[]);
int b_functor(MW arg[]);
int b_univ(MW arg[]);
int var_copy_term(MWPTR arg1ptr, MWPTR arg2ptr);
int copy_term(MWPTR arg1ptr, MWPTR arg2ptr);
int b_copy_term(MW arg[]);

int b_atom_length(MW arg[]);
int b_atom_list(MW arg[]);
int b_char_int(MW arg[]);
/* int b_concat(MW arg[]);
int b_sub_atom(MW arg[]); */

int struct_unify(MW m1, MW m2);
int unify(MWPTR m1ptr, MWPTR m2ptr);
int b_exit_true(void);
int b_exit_fail(void);
int b_block(void);
int b_exit_block(void);
int b_unify(MW arg[]);
int b_notunify(MW arg[]);
int b_equal(MW arg[]);
int b_notequal(MW arg[]);
int b_less(MW arg[]);
int b_greater(MW arg[]);
int b_equalless(MW arg[]);
int b_greaterequal(MW arg[]);

/* mc.c */

#define true        1
#define false        0

int compile_clause(MW clause, int atbegin, CODEPTR *headcodeptr);
int clause_decompile(MWPTR functor, CODEPTR clauseptr, MWPTR termptr);

int b_asserta(MW arg[]);
int b_assertz(MW arg[]);

 

/* mi.c */

int mi_interpreter(CODEPTR goalptr);
int mi_compiler(CODEPTR goalptr, int mode);
#ifdef Ass
int assinit(void);
#endif


/* mm.c */

extern MW       RuleAtom, CommaAtom, SColonAtom, VBarAtom, UserAtom,
                TrueAtom, DotAtom, CurlyBrackAtom;
extern MW       CutAtomIndex, NullAtomIndex, LCurlyAtomIndex, BlockAtomIndex, ExitBlockAtomIndex;
extern MW       PlusAtomIndex, MulAtomIndex, DivAtomIndex, ModAtomIndex;
extern MW       ShiftRightAtomIndex, ShiftLeftAtomIndex, BitAndAtomIndex,
                BitOrAtomIndex, BitNotAtomIndex, AbsAtomIndex;
extern MW       RuleAtomIndex, CommaAtomIndex, SColonAtomIndex, MinusAtomIndex;
extern MWPTR    RuleFunctor, CommaFunctor, SColonFunctor, CurlyBrackFunctor;
extern MWPTR    CutFunctor, NullFunctor, BlockFunctor, ExitBlockFunctor;

extern MWPTR    HeapStart, stackptr, StackStart, *TrailStart, CopyStart;
extern MWPTR    heapptr, copyptr, *trail;                       /* stackchange: no modification */
extern MWPTR    choicepntptr;

extern BIP_TAB  builtin[];

int mm_initialise(size_t heap_copy_size, size_t trail_stack_size);

int find_atom(char *stringptr, MWPTR atomptr);

MWPTR find_func(MW atom_index, MW arity);
MWPTR find_proc(MWPTR functor);
void indexing(MWPTR rootptr);
void insert_clause(MWPTR procptr, CODEPTR clauseptr, int atbegin);

int is_prefix_op(MW atom, int *oprec, int *rprec);
int is_postfix_op(MW atom, int *lprec, int *oprec);
int is_infix_op(MW atom, int *lprec, int *oprec, int *rprec);

int find_bip(MW index, MW arity);

int b_op(MW arg[]);
int b_abolish(MW arg[]);
int b_sysclause(MW arg[]);
int b_sysretract(MW arg[]);
int b_syscur_pred(MW arg[]);
int b_assemble(MW arg[]);


/* mr.c */

int scan_term(MWPTR mptr);
int display_term(MWPTR mptr);
int write_term(MWPTR mptr, int priority, int quoted);
int b_see(MW arg[]);
int b_tell(MW arg[]);
int b_seeing(MW arg[]);
int b_telling(MW arg[]);
int b_seen(void);
int b_told(void);
int b_get0(MW arg[]);
int b_get(MW arg[]);
int b_put(MW arg[]);
int b_read(MW arg[]);
int b_display(MW arg[]);
int b_write(MW arg[]);
int b_writeq(MW arg[]);
int b_eof(void);
int b_nl(void);

#ifdef Trace
#include "trace.h"
#else
#define TraceInstr(i) 
#define FailInstr(i)	
#define TraceAdd(i,s)	
#define ArgReset		
#define ArgFreeze(s)	
#define ArgIncr			
#define ReduceDeref(v,m)	
#define SetRepush		
#define ReSetRepush	
#define TraceChoice(i)	
#define TraceFrame(i)	
#define TraceStacks
#endif


